diff -Naurd cluster-3.0.0.rc2/group/gfs_controld/gfs_daemon.h cluster-3.0.0.rc3/group/gfs_controld/gfs_daemon.h
--- cluster-3.0.0.rc2/group/gfs_controld/gfs_daemon.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/gfs_controld/gfs_daemon.h	2009-06-11 11:02:55.000000000 +0200
@@ -214,9 +214,9 @@
 /* config.c */
 int setup_ccs(void);
 void close_ccs(void);
-void read_ccs_name(char *path, char *name);
-void read_ccs_yesno(char *path, int *yes, int *no);
-int read_ccs_int(char *path, int *config_val);
+void read_ccs_name(const char *path, char *name);
+void read_ccs_yesno(const char *path, int *yes, int *no);
+int read_ccs_int(const char *path, int *config_val);
 void read_ccs_nodir(struct mountgroup *mg, char *buf);
 
 /* cpg-new.c */
@@ -317,8 +317,8 @@
 
 /* util.c */
 int we_are_in_fence_domain(void);
-int set_sysfs(struct mountgroup *mg, char *field, int val);
-int read_sysfs_int(struct mountgroup *mg, char *field, int *val_out);
+int set_sysfs(struct mountgroup *mg, const char *field, int val);
+int read_sysfs_int(struct mountgroup *mg, const char *field, int *val_out);
 int run_dmsetup_suspend(struct mountgroup *mg, char *dev);
 void update_dmsetup_wait(void);
 void update_flow_control_status(void);
@@ -326,7 +326,7 @@
 
 /* logging.c */
 void init_logging(void);
-void setup_logging();
+void setup_logging(void);
 void close_logging(void);
 
 /* crc.c */
diff -Naurd cluster-3.0.0.rc2/group/gfs_controld/group.c cluster-3.0.0.rc3/group/gfs_controld/group.c
--- cluster-3.0.0.rc2/group/gfs_controld/group.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/gfs_controld/group.c	2009-06-11 11:02:55.000000000 +0200
@@ -286,7 +286,7 @@
 	return 0;
 }
 
-int list_count(struct list_head *head)
+static int list_count(struct list_head *head)
 {
 	struct list_head *tmp;
 	int count = 0;
diff -Naurd cluster-3.0.0.rc2/group/gfs_controld/main.c cluster-3.0.0.rc3/group/gfs_controld/main.c
--- cluster-3.0.0.rc2/group/gfs_controld/main.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/gfs_controld/main.c	2009-06-11 11:02:55.000000000 +0200
@@ -30,7 +30,7 @@
 	int rv, off = 0;
 
 	while (off < count) {
-		rv = read(fd, buf + off, count - off);
+		rv = read(fd, (char *)buf + off, count - off);
 		if (rv == 0)
 			return -1;
 		if (rv == -1 && errno == EINTR)
@@ -47,7 +47,7 @@
 	int rv, off = 0;
 
  retry:
-	rv = write(fd, buf + off, count);
+	rv = write(fd, (char *)buf + off, count);
 	if (rv == -1 && errno == EINTR)
 		goto retry;
 	if (rv < 0) {
@@ -984,7 +984,7 @@
 	log_debug("client connection %d fd %d", i, fd);
 }
 
-static int setup_listener(char *sock_path)
+static int setup_listener(const char *sock_path)
 {
 	struct sockaddr_un addr;
 	socklen_t addrlen;
@@ -1525,7 +1525,7 @@
 	}
 	lockfile();
 	init_logging();
-	log_level(LOG_INFO, "gfs_controld %s", RELEASE_VERSION);
+	log_level(LOG_INFO, "gfs_controld %s started", RELEASE_VERSION);
 	signal(SIGTERM, sigterm_handler);
 	set_scheduler();
 	set_oom_adj(-16);
diff -Naurd cluster-3.0.0.rc2/group/gfs_controld/plock.c cluster-3.0.0.rc3/group/gfs_controld/plock.c
--- cluster-3.0.0.rc2/group/gfs_controld/plock.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/gfs_controld/plock.c	2009-06-11 11:02:55.000000000 +0200
@@ -107,7 +107,7 @@
 	i->owner	= le64_to_cpu(i->owner);
 }
 
-static char *op_str(int optype)
+static const char *op_str(int optype)
 {
 	switch (optype) {
 	case DLM_PLOCK_OP_LOCK:
@@ -121,7 +121,7 @@
 	}
 }
 
-static char *ex_str(int optype, int ex)
+static const char *ex_str(int optype, int ex)
 {
 	if (optype == DLM_PLOCK_OP_UNLOCK || optype == DLM_PLOCK_OP_GET)
 		return "-";
@@ -1615,12 +1615,6 @@
 	}
 }
 
-void plock_exit(void)
-{
-	if (cfgd_enable_plock)
-		saCkptFinalize(ckpt_handle);
-}
-
 /* locks still marked SYNCING should not go into the ckpt; the new node
    will get those locks by receiving PLOCK_SYNC messages */
 
@@ -2326,7 +2320,7 @@
 		log_error("Is lock_dlm or dlm missing from kernel? No misc devices found.");
 }
 
-static int find_udev_device(char *path, uint32_t minor)
+static int find_udev_device(const char *path, uint32_t minor)
 {
 	struct stat st;
 	int i;
diff -Naurd cluster-3.0.0.rc2/group/gfs_controld/util.c cluster-3.0.0.rc3/group/gfs_controld/util.c
--- cluster-3.0.0.rc2/group/gfs_controld/util.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/gfs_controld/util.c	2009-06-11 11:02:55.000000000 +0200
@@ -47,7 +47,7 @@
 #define SYSFS_DIR       "/sys/fs"
 #define SYSFS_BUFLEN    64
 
-int set_sysfs(struct mountgroup *mg, char *field, int val)
+int set_sysfs(struct mountgroup *mg, const char *field, int val)
 {
 	char fname[PATH_MAX];
 	char out[SYSFS_BUFLEN];
@@ -78,7 +78,7 @@
 	return rv;
 }
 
-static int get_sysfs(struct mountgroup *mg, char *field, char *buf, int len)
+static int get_sysfs(struct mountgroup *mg, const char *field, char *buf, int len)
 {
 	char fname[PATH_MAX], *p;
 	int fd, rv;
@@ -108,7 +108,7 @@
 	return rv;
 }
 
-int read_sysfs_int(struct mountgroup *mg, char *field, int *val_out)
+int read_sysfs_int(struct mountgroup *mg, const char *field, int *val_out)
 {
 	char buf[SYSFS_BUFLEN];
 	int rv;
@@ -213,7 +213,7 @@
 	}
 }
 
-static int ignore_nolock(char *sysfs_dir, char *table)
+static int ignore_nolock(const char *sysfs_dir, char *table)
 {
 	char path[PATH_MAX];
 	int fd;
diff -Naurd cluster-3.0.0.rc2/group/lib/libgroup.c cluster-3.0.0.rc3/group/lib/libgroup.c
--- cluster-3.0.0.rc2/group/lib/libgroup.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/lib/libgroup.c	2009-06-11 11:02:55.000000000 +0200
@@ -131,7 +131,7 @@
 	int rv, off = 0;
 
  retry:
-	rv = write(fd, buf + off, count);
+	rv = write(fd, (char *)buf + off, count);
 	if (rv == -1 && errno == EINTR)
 		goto retry;
 	if (rv < 0)
@@ -150,7 +150,7 @@
 	int rv, off = 0;
 
 	while (off < count) {
-		rv = read(fd, buf + off, count - off);
+		rv = read(fd, (char *)buf + off, count - off);
 		if (rv == 0)
 			return -1;
 		if (rv == -1 && errno == EINTR)
@@ -172,7 +172,7 @@
 	char prog_name[32];
 };
 
-static int _joinleave(group_handle_t handle, char *name, char *cmd)
+static int _joinleave(group_handle_t handle, const char *name, const char *cmd)
 {
 	char buf[GROUPD_MSGLEN];
 	struct group_handle *h = (struct group_handle *) handle;
@@ -259,7 +259,7 @@
 	return fd;
 }
 
-group_handle_t group_init(void *private, char *prog_name, int level,
+group_handle_t group_init(void *private, const char *prog_name, int level,
 			  group_callbacks_t *cbs, int timeout)
 {
 	struct group_handle *h;
diff -Naurd cluster-3.0.0.rc2/group/lib/libgroup.h cluster-3.0.0.rc3/group/lib/libgroup.h
--- cluster-3.0.0.rc2/group/lib/libgroup.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/lib/libgroup.h	2009-06-11 11:02:55.000000000 +0200
@@ -36,7 +36,7 @@
 	group_deliver_t deliver;
 } group_callbacks_t;
 
-group_handle_t group_init(void *priv, char *prog_name, int level, group_callbacks_t *cbs, int timeout);
+group_handle_t group_init(void *priv, const char *prog_name, int level, group_callbacks_t *cbs, int timeout);
 int group_exit(group_handle_t handle);
 
 int group_join(group_handle_t handle, char *name);
diff -Naurd cluster-3.0.0.rc2/group/libgfscontrol/main.c cluster-3.0.0.rc3/group/libgfscontrol/main.c
--- cluster-3.0.0.rc2/group/libgfscontrol/main.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/libgfscontrol/main.c	2009-06-11 11:02:55.000000000 +0200
@@ -16,7 +16,7 @@
 	int rv, off = 0;
 
 	while (off < count) {
-		rv = read(fd, buf + off, count - off);
+		rv = read(fd, (char *)buf + off, count - off);
 		if (rv == 0)
 			return -1;
 		if (rv == -1 && errno == EINTR)
@@ -33,7 +33,7 @@
 	int rv, off = 0;
 
  retry:
-	rv = write(fd, buf + off, count);
+	rv = write(fd, (char *)buf + off, count);
 	if (rv == -1 && errno == EINTR)
 		goto retry;
 	if (rv < 0) {
@@ -48,7 +48,7 @@
 	return 0;
 }
 
-static int do_connect(char *sock_path)
+static int do_connect(const char *sock_path)
 {
 	struct sockaddr_un sun;
 	socklen_t addrlen;
@@ -86,7 +86,7 @@
 		strncpy(h->name, name, GFS_MOUNTGROUP_LEN);
 }
 
-int do_dump(int cmd, char *name, char *buf)
+static int do_dump(int cmd, char *name, char *buf)
 {
 	struct gfsc_header h, *rh;
 	char *reply;
diff -Naurd cluster-3.0.0.rc2/group/tool/main.c cluster-3.0.0.rc3/group/tool/main.c
--- cluster-3.0.0.rc2/group/tool/main.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/tool/main.c	2009-06-11 11:02:55.000000000 +0200
@@ -48,7 +48,7 @@
 	int rv, off = 0;
 
  retry:
-	rv = write(fd, buf + off, count);
+	rv = write(fd, (char *)buf + off, count);
 	if (rv == -1 && errno == EINTR)
 		goto retry;
 	if (rv < 0)
@@ -67,7 +67,7 @@
 	int rv, off = 0;
 
 	while (off < count) {
-		rv = read(fd, buf + off, count - off);
+		rv = read(fd, (char *)buf + off, count - off);
 		if (rv == 0)
 			return -1;
 		if (rv == -1 && errno == EINTR)
@@ -207,7 +207,7 @@
 #define EST_FAIL_START_WAIT   14
 #define EST_FAIL_ALL_STARTED  15
 
-char *ev_state_str(state)
+static const char *ev_state_str(int state)
 {
 	switch (state) {
 	case EST_JOIN_BEGIN:
@@ -245,10 +245,10 @@
 	}
 }
 
-char *state_str(group_data_t *data)
+static const char *state_str(group_data_t *data)
 {
 	static char buf[128];
-	
+
 	memset(buf, 0, sizeof(buf));
 
 	if (!data->event_state && !data->event_nodeid)
@@ -283,7 +283,8 @@
 {
 	group_data_t data[MAX_GROUPS];
 	int i, j, rv, count = 0, level, ret = 0;
-	char *name, *state_header;
+	char *name;
+	const char *state_header;
 	int type_width = 16;
 	int level_width = 5;
 	int name_width = 32;
@@ -301,7 +302,8 @@
 		count = 1;
 
 		/* don't output if there's no group at all */
-		if (data[0].id == 0) {
+		if (data[0].id == 0 && !strlen(data[0].name) && 
+		    !strlen(data[0].client_name)) {
 			fprintf(stderr, "groupd has no information about "
 			        "the specified group\n");
 			return 1;
@@ -557,7 +559,7 @@
 }
 #endif
 
-static int connect_daemon(char *path)
+static int connect_daemon(const char *path)
 {
 	struct sockaddr_un sun;
 	socklen_t addrlen;
diff -Naurd cluster-3.0.0.rc2/make/clean.mk cluster-3.0.0.rc3/make/clean.mk
--- cluster-3.0.0.rc2/make/clean.mk	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/make/clean.mk	2009-06-11 11:02:55.000000000 +0200
@@ -3,5 +3,5 @@
 	rm -rf core core.* .depend cscope.* *.orig *.rej
 	rm -rf linux .*.o.cmd .*.ko.cmd *.mod.c .tmp_versions
 	rm -rf Module.symvers Module.markers .*.o.d modules.order
-	rm -rf ${TARGET} ${TARGETS} ${TARGET}_test ${TARGET}.pc
+	rm -rf ${TARGET} ${TARGETS} ${TARGET}_test *.pc
 	rm -rf ${TARGET1} ${TARGET2} ${TARGET3} ${TARGET4} ${TARGET5} ${TARGET6}
diff -Naurd cluster-3.0.0.rc2/make/defines.mk.input cluster-3.0.0.rc3/make/defines.mk.input
--- cluster-3.0.0.rc2/make/defines.mk.input	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/make/defines.mk.input	2009-06-11 11:02:55.000000000 +0200
@@ -47,8 +47,6 @@
 fencelibdir ?= @FENCELIBDIR@
 logtincdir ?= @LOGTINCDIR@
 logtlibdir ?= @LOGTLIBDIR@
-volidincdir ?= @VOLIDINCDIR@
-volidlibdir ?= @VOLIDLIBDIR@
 readlineincdir ?= @READLINEINCDIR@
 readlinelibdir ?= @READLINELIBDIR@
 ncursesincdir ?= @NCURSESINCDIR@
@@ -80,7 +78,6 @@
 without_gfs-kernel/src/gfs ?= @DISABLE_GFSKERNEL@
 without_common ?= @DISABLE_COMMON@
 without_config ?= @DISABLE_CONFIG@
-without_cman/lib ?= @DISABLE_CMAN@
 without_cman ?= @DISABLE_CMAN@
 without_dlm ?= @DISABLE_DLM@
 without_group ?= @DISABLE_GROUP@
diff -Naurd cluster-3.0.0.rc2/make/official_release_version cluster-3.0.0.rc3/make/official_release_version
--- cluster-3.0.0.rc2/make/official_release_version	2009-05-07 09:29:45.000000000 +0200
+++ cluster-3.0.0.rc3/make/official_release_version	2009-06-11 15:46:20.000000000 +0200
@@ -1,2 +1,2 @@
 SONAME "3.0"
-VERSION "3.0.0.rc2"
+VERSION "3.0.0.rc3"
diff -Naurd cluster-3.0.0.rc2/make/perl-binding-common.mk cluster-3.0.0.rc3/make/perl-binding-common.mk
--- cluster-3.0.0.rc2/make/perl-binding-common.mk	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/make/perl-binding-common.mk	2009-06-11 11:02:55.000000000 +0200
@@ -27,4 +27,4 @@
 
 clean:
 	-${MAKE} -f Makefile clean
-	rm -f $(TARGET) Makefile.old
+	rm -f $(TARGET) Makefile.old *.d
diff -Naurd cluster-3.0.0.rc2/make/release.mk cluster-3.0.0.rc3/make/release.mk
--- cluster-3.0.0.rc2/make/release.mk	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/make/release.mk	2009-06-11 11:02:55.000000000 +0200
@@ -19,59 +19,65 @@
 
 else
 
+ifdef RELEASE
+TEST=""
+else
+TEST="test"
+endif
+
 ## setup stuff
 
 MASTERPROJECT=cluster
+
+ifdef RELEASE
 MASTERPV=$(MASTERPROJECT)-$(VERSION)
-MASTERTGZ=$(MASTERPV).tar.gz
-TESTTGZ=TEST-$(MASTERTGZ)
+else
+MASTERPV=HEAD
+endif
+MASTERTGZ=$(TEST)$(MASTERPROJECT)-$(VERSION).tar.gz
 
 # fence-agents
 FENCEPROJECT=fence-agents
 FENCEPV=$(FENCEPROJECT)-$(VERSION)
-FENCETGZ=$(FENCEPV).tar.gz
+FENCETGZ=$(TEST)$(FENCEPV).tar.gz
 
 # resource-agents
 RASPROJECT=resource-agents
 RASPV=$(RASPROJECT)-$(VERSION)
-RASTGZ=$(RASPV).tar.gz
-
-all: test-tarball
-
-test-tarball:
-	git archive \
-		--format=tar \
-		--prefix=$(MASTERPV)/ \
-		HEAD | \
-		gzip -9 \
-		> ../$(TESTTGZ)
+RASTGZ=$(TEST)$(RASPV).tar.gz
 
-release: tag tarballs
+all: tag tarballs
 
+ifdef RELEASE
 tag:
 	git tag -a -m "$(MASTERPV) release" $(MASTERPV) HEAD
 
+else
+tag:
+
+endif
+
 tarballs: master-tarball fence-agents-tarball resource-agents-tarball
 
 master-tarball:
 	git archive \
 		--format=tar \
-		--prefix=$(MASTERPV)/ \
+		--prefix=$(MASTERPROJECT)-$(VERSION)/ \
 		$(MASTERPV) | \
 		tar xp
 	sed -i -e \
 		's#<CVS>#$(VERSION)#g' \
-		$(MASTERPV)/gfs-kernel/src/gfs/gfs.h
+		$(MASTERPROJECT)-$(VERSION)/gfs-kernel/src/gfs/gfs.h
 	echo "VERSION \"$(VERSION)\"" \
-		>> $(MASTERPV)/make/official_release_version
-	tar cp $(MASTERPV) | \
+		>> $(MASTERPROJECT)-$(VERSION)/make/official_release_version
+	tar cp $(MASTERPROJECT)-$(VERSION) | \
 		gzip -9 \
 		> ../$(MASTERTGZ)
-	rm -rf $(MASTERPV)
+	rm -rf $(MASTERPROJECT)-$(VERSION)
 
 fence-agents-tarball:
 	tar zxpf ../$(MASTERTGZ)
-	mv $(MASTERPV) $(FENCEPV)
+	mv $(MASTERPROJECT)-$(VERSION) $(FENCEPV)
 	cd $(FENCEPV) && \
 		rm -rf bindings cman common config contrib dlm gfs* group rgmanager && \
 		rm -rf fence/fenced fence/fence_node fence/fence_tool fence/include fence/libfence fence/libfenced && \
@@ -84,7 +90,7 @@
 
 resource-agents-tarball:
 	tar zxpf ../$(MASTERTGZ)
-	mv $(MASTERPV) $(RASPV)
+	mv $(MASTERPROJECT)-$(VERSION) $(RASPV)
 	cd $(RASPV) && \
 		rm -rf bindings cman common config contrib dlm fence gfs* group && \
 		rm -rf rgmanager/ChangeLog rgmanager/errors.txt rgmanager/event-script.txt \
diff -Naurd cluster-3.0.0.rc2/Makefile cluster-3.0.0.rc3/Makefile
--- cluster-3.0.0.rc2/Makefile	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/Makefile	2009-06-11 11:02:55.000000000 +0200
@@ -1,7 +1,7 @@
 include make/defines.mk
 
 REALSUBDIRS = gfs-kernel/src/gfs \
-	      common cman/lib config cman dlm fence/libfenced group \
+	      common config cman dlm fence/libfenced group \
 	      fence gfs gfs2 rgmanager bindings doc \
 	      contrib
 
@@ -9,7 +9,6 @@
 	  $(if ${without_common},common) \
 	  $(if ${without_gfs-kernel/src/gfs},gfs-kernel/src/gfs) \
 	  $(if ${without_config},config) \
-	  $(if ${without_cman},cman/lib) \
 	  $(if ${without_cman},cman) \
 	  $(if ${without_dlm},dlm) \
 	  $(if ${without_fence},fence/libfenced) \
@@ -33,7 +32,7 @@
 # Dependencies
 
 common:
-config: cman/lib
+config:
 cman: common config
 dlm: config
 fence/libfenced:
diff -Naurd cluster-3.0.0.rc2/rgmanager/src/clulib/Makefile cluster-3.0.0.rc3/rgmanager/src/clulib/Makefile
--- cluster-3.0.0.rc2/rgmanager/src/clulib/Makefile	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/rgmanager/src/clulib/Makefile	2009-06-11 11:02:55.000000000 +0200
@@ -16,7 +16,7 @@
 
 OBJS2= msgtest.o
 
-CFLAGS += -Werror -Wstrict-prototypes -Wshadow -fPIC -D_GNU_SOURCE
+CFLAGS += -fPIC -D_GNU_SOURCE
 CFLAGS += -I${ccsincdir} -I${cmanincdir} -I${dlmincdir}
 CFLAGS += -I${logtincdir}
 CFLAGS += -I$(S)/../../include
diff -Naurd cluster-3.0.0.rc2/rgmanager/src/daemons/Makefile cluster-3.0.0.rc3/rgmanager/src/daemons/Makefile
--- cluster-3.0.0.rc2/rgmanager/src/daemons/Makefile	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/rgmanager/src/daemons/Makefile	2009-06-11 11:02:55.000000000 +0200
@@ -47,7 +47,7 @@
 		event_config-noccs.o
 
 CFLAGS += -DSHAREDIR=\"${sharedir}\"
-CFLAGS += -Werror -Wstrict-prototypes -Wshadow -fPIC
+CFLAGS += -fPIC
 CFLAGS += -I${ccsincdir} -I${cmanincdir} -I${dlmincdir} -I${logtincdir}
 CFLAGS += `xml2-config --cflags` -I${readlineincdir} -I${slangincdir}
 CFLAGS += -I$(S)/../../include
diff -Naurd cluster-3.0.0.rc2/rgmanager/src/daemons/watchdog.c cluster-3.0.0.rc3/rgmanager/src/daemons/watchdog.c
--- cluster-3.0.0.rc2/rgmanager/src/daemons/watchdog.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/rgmanager/src/daemons/watchdog.c	2009-06-11 11:02:55.000000000 +0200
@@ -3,6 +3,7 @@
 #include <sys/wait.h>
 #include <sys/reboot.h>
 #include <stdlib.h>
+#include <sys/mman.h>
 
 #include <signals.h>
 #include <logging.h>
@@ -50,6 +51,7 @@
 		return parent;
 	
 	redirect_signals();
+	mlockall(MCL_CURRENT); /* shouldn't need MCL_FUTURE */
 	
 	while (1) {
 	        if (waitpid(child, &status, 0) <= 0)
@@ -60,20 +62,22 @@
 		
 		if (WIFSIGNALED(status)) {
 		        if (WTERMSIG(status) == SIGKILL) {
-				logt_print(LOG_CRIT, "Watchdog: Daemon killed, exiting\n");
-				raise(SIGKILL);
-				while(1) ;
+				/* Assume the admin did a 'killall' - it will
+				 * kill us within a couple of seconds.  If 
+				 * we are still alive after this sleep, it
+				 * could have been the OOM killer killing
+				 * rgmanager proper and we need to reboot.
+				 */
+				sleep(3);
 			}
-			else {
 #ifdef DEBUG
-			        logt_print(LOG_CRIT, "Watchdog: Daemon died, but not rebooting because DEBUG is set\n");
+		        logt_print(LOG_CRIT, "Watchdog: Daemon died, but not rebooting because DEBUG is set\n");
 #else
-				logt_print(LOG_CRIT, "Watchdog: Daemon died, rebooting...\n");
-				sync();
-			        reboot(RB_AUTOBOOT);
+			logt_print(LOG_CRIT, "Watchdog: Daemon died, rebooting...\n");
+			sync();
+		        reboot(RB_AUTOBOOT);
 #endif
-				exit(255);
-			}
+			exit(255);
 		}
 	}
 }
diff -Naurd cluster-3.0.0.rc2/rgmanager/src/resources/apache.sh cluster-3.0.0.rc3/rgmanager/src/resources/apache.sh
--- cluster-3.0.0.rc2/rgmanager/src/resources/apache.sh	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/rgmanager/src/resources/apache.sh	2009-06-11 11:02:55.000000000 +0200
@@ -116,8 +116,12 @@
 
 	IFS_old="$IFS"
 	IFS=$'\n'
-	for i in `"$APACHE_parseConfig" -D"$OCF_RESKEY_name" < "$originalConfigFile" | grep -E '(^Listen)|(^Port)' | grep -v ':'`; do 
+	for i in `"$APACHE_parseConfig" -D"$OCF_RESKEY_name" < "$originalConfigFile" | grep -P '(^Listen)|(^Port)' `; do 
 		port=`echo $i | sed 's/^Listen \(.*\)/\1/;s/^Port \(.*\)/\1/'`;
+		testcond=`echo $port|grep :`
+		if [ $testcond ]; then
+			port=`echo $port|awk -F : '{print $2}'`
+		fi
 		IFS=$' ';
 		for z in $ip_addresses; do 
 			echo "Listen $z:$port" >> "$generatedConfigFile";
diff -Naurd cluster-3.0.0.rc2/rgmanager/src/resources/default_event_script.sl cluster-3.0.0.rc3/rgmanager/src/resources/default_event_script.sl
--- cluster-3.0.0.rc2/rgmanager/src/resources/default_event_script.sl	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/rgmanager/src/resources/default_event_script.sl	2009-06-11 11:02:55.000000000 +0200
@@ -254,6 +254,154 @@
 	return anodes;
 }
 
+%
+% Returns the set of online nodes in preferred/shuffled order which
+% are allowed to run this service.  Gives highest preference to current
+% owner if nofailback is specified.
+% 
+define allowed_nodes(service)
+{
+	variable anodes;
+	variable online;
+	variable nodes_domain;
+	variable ordered, restricted, nofailback;
+	variable state, owner;
+	variable depends;
+
+	(nofailback, restricted, ordered, nodes_domain) =
+			service_domain_info(service);
+	(owner, state) = service_status(service);
+
+	anodes = nodes_online();
+
+	% Shuffle the array so we don't start all services on the same
+	% node.  TODO - add RR, Least-services, placement policies...
+	online = shuffle(anodes);
+
+	if (restricted == 1) {
+		anodes = intersection(nodes_domain, online);
+	} else {
+		% Ordered failover domains (nodes_domain) unioned with the
+		% online nodes basically just reorders the online node list
+		% according to failover domain priority rules.
+		anodes = union(intersection(nodes_domain, online),
+			       online);
+	}
+
+	if ((nofailback == 1) or (ordered == 0)) {
+		
+		if ((owner < 0) or (node_in_set(anodes, owner) == 0)) {
+			return anodes;
+		}
+		
+		% Because union takes left as priority, we can
+		% return the union of the current owner with the
+		% allowed node list.  This means the service will
+		% remain on the same node it's currently on.
+		return union(owner, anodes);
+	}
+
+	return anodes;
+}
+
+define string_list(thelist, delimiter)
+{
+	variable index;
+	variable output="";
+
+	if (length(thelist) == 0) {
+		return output;
+	}
+  
+	for (index=0; index < length(thelist)-1; index++) {
+		output=output+string(thelist[index])+delimiter;
+	}
+	return output+thelist[index];
+}
+
+% this function gets the smallest property from a given list of services
+% if the list only exists of one element the property itself is returned
+% if the given property is not found 0 is returned
+define services_min_attribute(services, property)
+{
+	variable x;
+	variable min_property=-1;
+	variable tmp_property;
+
+	for (x = 0; x < length(services); x++) {
+		tmp_property=service_property(services[x], property);
+		if (tmp_property == NULL) {
+			tmp_property=0;
+		} else {
+			tmp_property=atoi(tmp_property);
+		}
+		if ((min_property < 0) or (tmp_property < min_property)) {
+			min_property=tmp_property;
+		}
+		%debug("services_min_attribute: ",services[x]," attribute: ",min_property, "tmp: ", tmp_property, " min: ", min_property);
+	}
+
+	%debug("services_min_attribute: (", string_list(services, ", "),")[",property,"]: ",min_property);
+
+	return min_property;
+}
+
+% This function will sort a given service_list by the given attribute name and
+% return the list
+define sorted_service_list(services, attribute)
+{
+	variable work_queue={};
+	variable sorted_list={}, tmp, tmp2;
+	variable x, y;
+	variable cur_min_prop=0;
+	variable service_prop=0;
+
+	y=0;
+	%debug("sorted_service_list: ", strjoin(services, ", "));
+	for (x=0; x<length(services); x++) {
+		list_append(work_queue, string(services[x]));
+	}
+
+	%debug("sorted_service_list: work_queue ", string_list(work_queue, ", "));
+	while (length(work_queue) > 0) {
+		cur_min_prop=services_min_attribute(work_queue, attribute);
+		%debug("sorted_service_list sorting services list for attribute ", attribute, " cur_min: ",cur_min_prop);
+		for (x = 0; x < length(work_queue); x++) {
+			service_prop=service_property(work_queue[x], "priority");
+			if (service_prop == NULL) {
+				service_prop=0;
+			} else {
+				service_prop=atoi(service_prop);
+			}
+			%debug("sorted_service_list: ",work_queue[x], " property[", attribute,"]: ",service_prop);
+			if (cur_min_prop==service_prop) {
+				%debug("sorted_service_list: adding service ",work_queue[x]," to sorted. work_queue: ", string_list(work_queue, ", "));
+				list_append(sorted_list, work_queue[x]);
+				%debug("sorted_service_list: sorted_list: ", string_list(sorted_list, ", "));
+				%debug("sorted_service_list: removing service ",work_queue[x], " from work_queue ", string_list(work_queue, ", "));
+				list_delete(work_queue, x);
+				x=x-1;
+				%debug("sorted_service_list: work_queue: ",string_list(work_queue, ", "));
+				y=y+1;
+			}
+		}
+	}
+
+	debug("sorted_service_list ", string_list(sorted_list, ", "));
+	return sorted_list;
+}
+
+define sortedservices_node_event_handler(services, attribute) {
+	variable x;
+	variable nodes;
+
+	services=sorted_service_list(services, attribute);
+	for (x = 0; x < length(services); x++) {
+		debug("Executing sortedservices node event handler for service: ", services[x]);
+		nodes = allowed_nodes(services[x]);
+		()=move_or_start(services[x], nodes);
+	}
+}
 
 define default_node_event_handler()
 {
@@ -447,7 +595,7 @@
 }
 
 if (event_type == EVENT_NODE)
-	default_node_event_handler();
+	sortedservices_node_event_handler(service_list(), "priority");
 if (event_type == EVENT_SERVICE)
 	default_service_event_handler();
 if (event_type == EVENT_CONFIG)
diff -Naurd cluster-3.0.0.rc2/rgmanager/src/resources/oracledb.sh.in cluster-3.0.0.rc3/rgmanager/src/resources/oracledb.sh.in
--- cluster-3.0.0.rc2/rgmanager/src/resources/oracledb.sh.in	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/rgmanager/src/resources/oracledb.sh.in	2009-06-11 11:02:55.000000000 +0200
@@ -217,13 +217,8 @@
 	<action name="status" timeout="10"/>
 	<action name="monitor" timeout="10"/>
 
-	<!-- Checks to see if we can read from the mountpoint -->
-	<action name="status" depth="10" timeout="30" interval="5m"/>
-	<action name="monitor" depth="10" timeout="30" interval="5m"/>
-
-	<!-- Checks to see if we can write to the mountpoint (if !ROFS) -->
-	<action name="status" depth="20" timeout="90" interval="10m"/>
-	<action name="monitor" depth="20" timeout="90" interval="10m"/>
+	<action name="status" depth="10" timeout="30" interval="30"/>
+	<action name="monitor" depth="10" timeout="30" interval="30"/>
 
 	<action name="meta-data" timeout="5"/>
 	<action name="validate-all" timeout="5"/>
@@ -296,9 +291,11 @@
 	# ORA-.....: failure, we failed
 	#
 
-	grep -q "failure" $logfile
+	rm -f $tmpfile
+	grep -q "^ORA-" $logfile
 	if [ $? -eq 0 ]; then
 		echo "ORACLE_SID Incorrectly set?"
+		rm -f $tmpfile
 		echo "See $logfile for more information."
 		return 1
 	fi
@@ -340,7 +337,8 @@
 	# 
 	# If we see 'failure' in the log, we're done.
 	#
-	grep -q failure $logfile
+	rm -f $tmpfile
+	grep -q "^ORA-" $logfile
 	if [ $? -eq 0 ]; then
 		echo_failure
 		echo
@@ -361,7 +359,8 @@
 	declare pids
 	declare pid
 
-	pids=`ps ax | grep $ORACLE_HOME | grep -v grep | awk '{print $1}'`
+	# Patch from Shane Bradley to fix 471266
+	pids=`ps ax | grep $ORACLE_HOME | grep "ora_.*_${ORACLE_SID}" | grep -v grep | awk '{print $1}'`
 
 	initlog -n $SCRIPT -s "<err> Not all Oracle processes exited cleanly, killing"
 	
@@ -809,7 +808,6 @@
 {
 	declare -i subsys_lock=1
 	declare -i last 
-	declare -i depth=$1
 
 	#
 	# Check for lock file.  Crude and rudimentary, but it works
@@ -819,12 +817,12 @@
 	fi
 
 	# Check database status
-	get_db_status $subsys_lock $depth
+	get_db_status $subsys_lock
 	update_status $? # Start
 	last=$?
 
 	# Check & report listener status
-	get_lsnr_status $subsys_lock $depth
+	get_lsnr_status $subsys_lock
 	update_status $? $last
 	last=$?
 	
@@ -835,7 +833,7 @@
 		last=$?
 	elif [ "$ORACLE_TYPE" = "ias" ]; then
 		# Check & report opmn / opmn-managed process status
-		get_opmn_status $subsys_lock $depth
+		get_opmn_status $subsys_lock
 		update_status $? $last
 		last=$?
 	fi
@@ -872,7 +870,7 @@
 		exit $?
 		;;
 	status|monitor)
-		status_oracle $OCF_CHECK_LEVEL
+		status_oracle
 		exit $?
 		;;
 	restart)
diff -Naurd cluster-3.0.0.rc2/rgmanager/src/resources/service.sh cluster-3.0.0.rc3/rgmanager/src/resources/service.sh
--- cluster-3.0.0.rc2/rgmanager/src/resources/service.sh	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/rgmanager/src/resources/service.sh	2009-06-11 11:02:55.000000000 +0200
@@ -197,16 +197,31 @@
             <content type="string" default="0"/>
         </parameter>
 
+	<parameter name="priority">
+	    <longdesc lang="en">
+		Priority for the service.  In a failover scenario, this
+		indicates the ordering of the service (1 is processed
+		first, 2 is processed second, etc.).  This overrides the
+		order presented in cluster.conf.  This option only has
+		an effect if central processing within rgmanager is turned
+		on.
+	    </longdesc>
+	    <shortdesc lang="en">
+		Service priority
+	    </shortdesc>
+	    <content type="integer" default="0"/>
+	</parameter>
+
     </parameters>
 
     <actions>
         <action name="start" timeout="5"/>
         <action name="stop" timeout="5"/>
 	
-	<!-- No-ops.  Groups are abstract resource types.
+	<!-- No-ops.  Groups are abstract resource types. 
         <action name="status" timeout="5" interval="1h"/>
         <action name="monitor" timeout="5" interval="1h"/>
-       	 -->
+ -->
 
         <action name="reconfig" timeout="5"/>
         <action name="recover" timeout="5"/>
